忘记密码   免费注册 查看新帖 | 论坛精华区

ChinaUnix.net

  平台 论坛 博客 认证专区 大话IT HPC论坛 徽章 文库 沙龙 自测 下载 频道自动化运维 虚拟化 储存备份 C/C++ PHP MySQL 嵌入式 Linux系统
最近访问板块 发新帖
查看: 1210 | 回复: 2

[C++] linux上面std::thread抛出的异常,异常信息没有看懂,请教! [复制链接]

论坛徽章:
2
2015年迎新春徽章
日期:2015-03-04 10:16:532015元宵节徽章
日期:2015-03-06 15:53:22
发表于 2017-08-11 21:23 |显示全部楼层
在RHEL 7上面(G++ 4.8.5)编译运行下面的程序:
  1. #include <iostream>
  2. #include <string>
  3. #include <thread>
  4. using namespace std;
  5. struct N{
  6.     string s;
  7.     N(){}
  8.     ~N(){cout<<"N dtor"<<endl;}
  9. };

  10. void f(){
  11.     N n;
  12.     throw 0;
  13. }
  14. int main(){
  15.     try{
  16.         thread a(f), b(f);
  17.         a.join();
  18.         b.join();
  19.     }catch(exception& e){
  20.         cout<<e.what()<<endl;
  21.     }
  22.     return 0;
  23. }
复制代码


输出打印:

  1. $g++ 2.cpp -std=c++11 -lpthread && ./a.out
  2. N dtorN dtor

  3. terminate called after throwing an instance of 'int'
  4. terminate called recursively
  5. Aborted

复制代码


问题:
为什么try/catch没有抓住throw出来的int异常,看起来thread函数f内部已经做了stack unwind,因为N的析构函数调用了。但是try/catch似乎没有用,线程terminated。

这是为何? 谢谢。

论坛徽章:
0
发表于 2017-08-12 14:35 |显示全部楼层
try/catch 只能抓本线程(main的主线程)的异常,你在其他线程(新开的线程)抛的异常,当然不会被抓到了,然后就缺省abort了,然后abort就重入了

评分

参与人数 1信誉积分 +10 收起 理由
cdsfiui + 10 赞一个!

查看全部评分

论坛徽章:
35
子鼠
日期:2013-08-28 22:23:29黄金圣斗士
日期:2015-12-01 11:37:51程序设计版块每日发帖之星
日期:2015-12-14 06:20:00CU十四周年纪念徽章
日期:2015-12-22 16:50:40IT运维版块每日发帖之星
日期:2016-01-25 06:20:0015-16赛季CBA联赛之深圳
日期:2016-01-27 10:31:172016猴年福章徽章
日期:2016-02-18 15:30:3415-16赛季CBA联赛之福建
日期:2016-04-07 11:25:2215-16赛季CBA联赛之青岛
日期:2016-04-29 18:02:5915-16赛季CBA联赛之北控
日期:2016-06-20 17:38:50技术图书徽章
日期:2016-07-19 13:54:03程序设计版块每日发帖之星
日期:2016-08-21 06:20:00
发表于 2017-08-12 17:51 |显示全部楼层
通常情况下,你跳槽到另一家公司了,本公司待遇就不会再享受了。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

  

北京盛拓优讯信息技术有限公司. 版权所有 京ICP备16024965号 北京市公安局海淀分局网监中心备案编号:11010802020122
广播电视节目制作经营许可证(京) 字第1234号 中国互联网协会会员  联系我们:
感谢所有关心和支持过ChinaUnix的朋友们 转载本站内容请注明原作者名及出处

清除 Cookies - ChinaUnix - Archiver - WAP - TOP